> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.privategpt.dev/llms.txt.
> For full documentation content, see https://docs.privategpt.dev/llms-full.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.privategpt.dev/_mcp/server.

# Chunks Retrieval

POST https://host.com/v1/chunks
Content-Type: application/json

Given a `text`, returns the most relevant chunks from the ingested documents.

The returned information can be used to generate prompts that can be
passed to `/completions` or `/chat/completions` APIs. Note: it is usually a very
fast API, because only the Embeddings model is involved, not the LLM. The
returned information contains the relevant chunk `text` together with the source
`document` it is coming from. It also contains a score that can be used to
compare different results.

The max number of chunks to be returned is set using the `limit` param.

Previous and next chunks (pieces of text that appear right before or after in the
document) can be fetched by using the `prev_next_chunks` field.

The documents being used can be filtered using the `context_filter` and passing
the document IDs to be used. Ingested documents IDs can be found using
`/ingest/list` endpoint. If you want all ingested documents to be used,
remove `context_filter` altogether.

Reference: https://docs.privategpt.dev/api-reference/api-reference/context-chunks/chunks-retrieval

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: API
  version: 1.0.0
paths:
  /v1/chunks:
    post:
      operationId: chunks-retrieval
      summary: Chunks Retrieval
      description: >-
        Given a `text`, returns the most relevant chunks from the ingested
        documents.


        The returned information can be used to generate prompts that can be

        passed to `/completions` or `/chat/completions` APIs. Note: it is
        usually a very

        fast API, because only the Embeddings model is involved, not the LLM.
        The

        returned information contains the relevant chunk `text` together with
        the source

        `document` it is coming from. It also contains a score that can be used
        to

        compare different results.


        The max number of chunks to be returned is set using the `limit` param.


        Previous and next chunks (pieces of text that appear right before or
        after in the

        document) can be fetched by using the `prev_next_chunks` field.


        The documents being used can be filtered using the `context_filter` and
        passing

        the document IDs to be used. Ingested documents IDs can be found using

        `/ingest/list` endpoint. If you want all ingested documents to be used,

        remove `context_filter` altogether.
      tags:
        - subpackage_contextChunks
      responses:
        '200':
          description: Response with status 200
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/type_:ChunksResponse'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/type_:HTTPValidationError'
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                text:
                  type: string
                context_filter:
                  $ref: '#/components/schemas/type_:ContextFilter'
                limit:
                  type: integer
                  default: 10
                prev_next_chunks:
                  type: integer
                  default: 0
              required:
                - text
servers:
  - url: https://host.com
components:
  schemas:
    type_:ContextFilter:
      type: object
      properties:
        docs_ids:
          type: array
          items:
            type: string
      title: ContextFilter
    type_:IngestedDoc:
      type: object
      properties:
        object:
          type: string
          enum:
            - ingest.document
        doc_id:
          type: string
        doc_metadata:
          type: object
          additionalProperties:
            description: Any type
      required:
        - object
        - doc_id
      title: IngestedDoc
    type_:Chunk:
      type: object
      properties:
        object:
          type: string
          enum:
            - context.chunk
        score:
          type: number
          format: double
        document:
          $ref: '#/components/schemas/type_:IngestedDoc'
        text:
          type: string
        previous_texts:
          type: array
          items:
            type: string
        next_texts:
          type: array
          items:
            type: string
      required:
        - object
        - score
        - document
        - text
      title: Chunk
    type_:ChunksResponse:
      type: object
      properties:
        object:
          type: string
          enum:
            - list
        model:
          type: string
          enum:
            - private-gpt
        data:
          type: array
          items:
            $ref: '#/components/schemas/type_:Chunk'
      required:
        - object
        - model
        - data
      title: ChunksResponse
    type_:ValidationErrorLocItem:
      oneOf:
        - type: string
        - type: integer
      title: ValidationErrorLocItem
    type_:ValidationError:
      type: object
      properties:
        loc:
          type: array
          items:
            $ref: '#/components/schemas/type_:ValidationErrorLocItem'
        msg:
          type: string
        type:
          type: string
      required:
        - loc
        - msg
        - type
      title: ValidationError
    type_:HTTPValidationError:
      type: object
      properties:
        detail:
          type: array
          items:
            $ref: '#/components/schemas/type_:ValidationError'
      title: HTTPValidationError

```

## SDK Code Examples

```python
import requests

url = "https://host.com/v1/chunks"

payload = { "text": "text" }
headers = {"Content-Type": "application/json"}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://host.com/v1/chunks';
const options = {
  method: 'POST',
  headers: {'Content-Type': 'application/json'},
  body: '{"text":"text"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://host.com/v1/chunks"

	payload := strings.NewReader("{\n  \"text\": \"text\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://host.com/v1/chunks")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Content-Type"] = 'application/json'
request.body = "{\n  \"text\": \"text\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://host.com/v1/chunks")
  .header("Content-Type", "application/json")
  .body("{\n  \"text\": \"text\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://host.com/v1/chunks', [
  'body' => '{
  "text": "text"
}',
  'headers' => [
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://host.com/v1/chunks");
var request = new RestRequest(Method.POST);
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"text\": \"text\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = ["Content-Type": "application/json"]
let parameters = ["text": "text"] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://host.com/v1/chunks")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```